/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 16.06.2017
Author  : PerTic@n
Company : If You Like This Software,Buy It
Comments: 


Chip type               : ATtiny2313
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 32
*****************************************************/

#include <tiny2313.h>  
#include <delay.h>

#include <Digits.c>
#define KEY_IN PIND.1
eeprom signed int E_MIN_T=50;
eeprom signed int E_MAX_T=150;
unsigned char Count=0;
unsigned char KeyP;
unsigned char StartOn=0;
signed int MIN_T;
signed int MAX_T;
#define Run PORTA.1
#define ERR PORTD.2
unsigned char DIGS[4];
signed int  Temperature=-2000;
#include <DS18B20.c>
#define L_Max 254
#define L_Min 2

void digit(signed int ish)
{
if (0>ish)  {ish=-ish; DIGS[3]=~_G;}else{if (999<ish) {DIGS[3]=DIG[1]; ish-=1000;}else{DIGS[3]=~0;};};
if (1280<ish) {DIGS[2]=~_G; DIGS[1]=~_G; DIGS[0]=~_G;}
else
  {
  DIGS[0]=DIG[ish%10];
  ish/=10;
  DIGS[2]=DIG[ish%10]&(~_DP);
  ish/=10;
  DIGS[1]=DIG[ish];
  };
} 

// Timer 0 output compare A interrupt service routine
interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
//ERR=1;
if (KEY_IN) KeyP|=PORTD&0x78; 
_OFF;
}

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{//ERR=1;
static unsigned char NUM;
static unsigned char Msec; 
//static unsigned char DelyGetTemp;
//static unsigned int  Sec;
//static signed int  Temperature;
//static unsigned int  SecStop;
//static unsigned int  SuHo;
//static unsigned int  Pokaz;
//static unsigned char KeyP;
static unsigned char menu=0;
//if (KEY_IN) KeyP|=PORTD&(0xFF);
//if (KEY_IN) KeyP|=PORTD;
//_OFF;
_N_Dig;
_ON;
#asm("sei")
NUM=++NUM&3;
switch (NUM)
{
case 2: 
       Msec=++Msec&31;
       if (0==KeyP) Msec=0; 
       if (!Msec)
       switch (menu) 
       {
       case 0:switch (KeyP)               //    
              {
              case  0:
                      digit(Temperature);
                      break;
              case 16:
                      digit(MIN_T); 
                      DIGS[3]&=~_E;  
                      break;  
              case 32:
                      digit(MAX_T); 
                      DIGS[3]&=~_F; 
                      break; 
              case 48:
                      digit(-3000);
                      menu=1;
                      break; 
              default: digit(KeyP);
              }break;
       case 1:
              DIGS[3]&=~_E;  
              if (0==KeyP) menu=2; 
              break;        
       case 2:switch (KeyP)                //
              {
              case  0:
                      digit(MIN_T); 
                      DIGS[3]&=~_E;  
                      break;
              case 16:
                      MIN_T--;
                      MIN_T+=(-550>MIN_T)? 1:0;
                      digit(MIN_T); 
                      DIGS[3]&=~_E;  
                      break;  
              case 32:
                      MIN_T++;
                      if (MAX_T<=MIN_T) MIN_T=MAX_T-1;
                      digit(MIN_T); 
                      DIGS[3]&=~_E; 
                      break; 
              case 48:
                      digit(-3000);
                      menu=3;
                      break; 
              default: digit(KeyP);
              }break;                                   
       case 3:
              DIGS[3]&=~_F;
              if (0==KeyP) menu=4; 
              break;        
       case 4:switch (KeyP)               //
              {
              case  0:
                      digit(MAX_T); 
                      DIGS[3]&=~_F; 
                      break;
              case 16:
                      MAX_T--;
                      if (MAX_T<=MIN_T) MAX_T=MIN_T+1;
                      digit(MAX_T); 
                      DIGS[3]&=~_F;  
                      break;  
              case 32:
                      MAX_T++; 
                      MAX_T-=(1250<MAX_T)? 1:0;
                      digit(MAX_T); 
                      DIGS[3]&=~_F; 
                      break; 
              case 48:
                      digit(-3000);
                      menu=5;
                      break; 
              default: digit(KeyP);               
              }; break;
       case 5:
              if (0==KeyP) 
                 {
                 menu=6;
                 E_MIN_T=MIN_T;
                 E_MAX_T=MAX_T;
                 Count=0;
                 menu=0; 
                 };
               break;        
       case 6: break;
       default: menu=0;
       };
              KeyP=0;    
 if (DelyGetTemp){DelyGetTemp--;}else{GetTemp();}; // 250 
                  
        break;
case 3: //  (m4Sec>=125)
        //digit(Temperature);
        break;
case 0:
       if (PINA.0) {OCR0A+=(L_Max>OCR0A)? 1:0;}       //
       else {OCR0A-=(L_Min<OCR0A)? 1:0;};
       break;
case 1: 
        if ((8<Count)&&(0==menu))                                  //- 
         {
         if (MIN_T>Temperature) {if (StartOn) Run=1; else Run=0;};
         if (MAX_T<Temperature) {if (StartOn) Run=0; else Run=1;};
         } 
            
        break;
};
}

// Declare your global variables here
void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=In Func0=In 
// State2=P State1=T State0=P 
PORTA=0x05;
DDRA=0x00;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0xFF;

// Port D initialization
// Func6=Out Func5=Out Func4=Out Func3=Out Func2=In Func1=In Func0=In 
// State6=0 State5=0 State4=0 State3=0 State2=P State1=T State0=T 
PORTD=0x04;
DDRD=0x7C;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x03;
TCNT0=0x00;
OCR0A=0xFA;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
//TCNT1H=0x00;
//TCNT1L=0x00;
//ICR1H=0x00;
//ICR1L=0x00;
//OCR1AH=0x00;
//OCR1AL=0x00;
//OCR1BH=0x00;
//OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
//GIMSK=0x00;
MCUCR=0x20;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x03;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
//USICR=0x00;

// USART initialization
// USART disabled
//UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
//DIDR=0x00;
StartOn=0;
delay_us(100);
if (PINA.1) StartOn=1; 
if (StartOn) Run=1;
DDRA=2;
//delay_us(100);

//Run=1;
//if (~E_MIN_T) E_MIN_T=0;
//if (~E_MAX_T) E_MAX_T=50;
MIN_T=E_MIN_T;
MAX_T=E_MAX_T;
//OSCCAL=20;
// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here   
      //ERR=0;
      #asm("sleep")
      }
}
