//DS18B20
//if (DelyGetTemp){DelyGetTemp--;}else{GetTemp();}; // 250  

//#define PORTTEMP       PORTD                                    //      
#define DDRTEMP           DDRD                                    //         
#define PINTEMP           PIND                                    //         
//#define BITTEMP            0                                    //       
#define BT                   0                                    //       
#define Speed_temp       0.122                                    //    

#define TR0 DDRTEMP |= (1 << BT)
#define TR1 DDRTEMP &= ~(1 << BT)
//#define TR0 DDRTEMP.BT=1
//#define TR1 DDRTEMP.BT=0
#define RES PINTEMP.BT
volatile bit           OK_Flag = 0;
volatile unsigned char  DelyGetTemp = 1000*Speed_temp;                         //    1 .
//___________________________________________________________________________________________________________________________________________________
//                                                        DS18B20
//___________________________________________________________________________________________________________________________________________________
void DS18B20_init(void)
 {              
 //PORTTEMP.BT=0;//PORTTEMP &= ~(1 << BT);           //           
 TR0;                                              //   
 delay_us(490);                                    //    480    490
 TR1;                                              //  
 delay_us(2); 
 OK_Flag = ~(RES);                                 //   
 delay_us(70);                                     //    60     68
 OK_Flag |= RES;                                   //     //  OK_Flag = 0  
 delay_us(420);                                    //    420     422
 //return OK_Flag;                                   //  
 }  
//___________________________________________________________________________________________________________________________________________________
//                                                          DS18B20
//___________________________________________________________________________________________________________________________________________________
unsigned char read_18b20(void)
 {
 unsigned char i;
 unsigned char dat = 0;
 //#asm("CLI")
 for (i=0; i<8; i++)                               //  
  {
  TR0;                                          //   
  delay_us(2);                                  //    1 
  TR1;                                          // 
  delay_us(4);                                  //    2              
  dat|=RES<<i;                                  //      
  delay_us(62);                                 //    2 
  };
 //#asm("SEI")
 return dat;                                       //      
 }
//___________________________________________________________________________________________________________________________________________________
//                                                          DS18B20
//___________________________________________________________________________________________________________________________________________________
void write_18b20(unsigned char dat)
 {
 unsigned char i;
 //#asm("CLI")
 for (i = 0;i < 8;i++)
  {
  TR0;
  delay_us(2);
  if (dat & (1<<i)) {TR1;}else{TR0;}
  delay_us(62);
  TR1;
  delay_us(2);
  }; 
 //#asm("SEI")    
 }
//___________________________________________________________________________________________________________________________________________________
//                                                                  
//___________________________________________________________________________________________________________________________________________________
void GetTemp(void)
 {
 static   unsigned int StepGetTemp = 0;     
 static   unsigned char TermH, TermL;
 switch (StepGetTemp) 
  {        /*DelyGetTemp=750*Speed_temp;*/   case 0:              // ,      ,         
   DS18B20_init();                                            //  DS18B20    
  StepGetTemp=1; DelyGetTemp=0;   break; case 1:                                              
   write_18b20(0xCC);                                         //   
  StepGetTemp=2; DelyGetTemp=0;   break; case 2: 
   write_18b20(0x44);                                         //                                            
  StepGetTemp=3; DelyGetTemp=850*Speed_temp; break; case 3:   //  750                                          
   DS18B20_init();                                            //  DS18B20
  StepGetTemp=4; DelyGetTemp=0;   break; case 4:                                           
   write_18b20(0xCC);                                         //   
  StepGetTemp=5; DelyGetTemp=0;   break; case 5: 
   write_18b20(0xBE);                                         //   
  StepGetTemp=6; DelyGetTemp=0;   break; case 6: 
  // Term = read_18b20()>>4;                                    //    
   TermL = read_18b20();                                    //    
   //TermL=16;
  StepGetTemp=7; DelyGetTemp=0;   break; case 7: 
  // Term |= read_18b20()<<4;                                   //    
   TermH = read_18b20();                                   //    
  // TermH = 1;
  ////Term = (OK_Flag == 0)? ((Temp_L>>4)|(Temp_H<<4)):-126;  
   //if (OK_Flag != 0) Term = -126;       
   StepGetTemp=8; DelyGetTemp=0;   break; case 8:
   //if (Term<0) Term=(-Term)|0x80;                             //     .    
    //Term=0x8100;   
    //Temperature=(TermH<<8)+TermL; 
    //if (Temperature<0) Temperature=(-Temperature)|0x8000; 
    //if (OK_Flag != 0) Temperature = -2050;  
    //Temperature=(Temperature<0)? ((-Temperature)|0x8000):(Temperature);  
    //Temperature=(Temperature*10)>>4;  
    Temperature=(((TermH<<8)+TermL)*10)>>4; 
    if (OK_Flag != 0) {Temperature = -2000; Count=0;};   
    Count+=(~Count)? 1:0;
  default: StepGetTemp=0;                                                                                                   
  DelyGetTemp=1000*Speed_temp;                                //    1
  };                                                           
 }
   